uniform sampler2D texture0_2D;
varying vec4 diffuse,ambient;
varying vec3 normal,lightDir,halfVector;

/*vec4 saturate(vec4 inp)
{
  return clamp(inp, 0.0, 1.0);
}*/

void main(void)
{
   vec4 return_color;
   /*  material */
    vec3 n,halfV,viewV,ldir;
	float NdotL,NdotHV;
	vec4 color = ambient;
	
	n = normalize(normal);
	
	NdotL = max(dot(n,lightDir),0.0);

	if (NdotL > 0.0) {
		halfV = normalize(halfVector);
		NdotHV = max(dot(n,halfV),0.0);
		color += gl_FrontMaterial.specular * gl_LightSource[0].specular * pow(NdotHV,gl_FrontMaterial.shininess);
		color += diffuse * NdotL;
	}
	 if ((color.r > 0.75)&&(color.g > 0.75)&&(color.b > 0.75))
        return_color =  vec4(1.0, 1.0, 1.0, 1.0);
     else 
        return_color =   vec4(0.0,0.0,0.0,0.0);
   /* texture */	
   if (return_color.r == 0.0){  
      //if there is nothing in the bloom, could be in texture
     vec4 texcolor = texture2D(texture0_2D, gl_TexCoord[0].xy );
   
     if ((texcolor.r > 0.98)&&(texcolor.g > 0.98)&&(texcolor.b > 0.98))
        return_color =  vec4(1.0, 1.0, 1.0, 1.0);
      else   
        return_color =  vec4(0.0,0.0,0.0,0.0);
   }    
   gl_FragColor = return_color;

 }

